#ifndef DEBUG_STRUCTS_H
#define DEBUG_STRUCTS_H

#include "var_array.h"

typedef struct
{
	var_array_cf_t preamble_symbols;
	var_array_cf_t header_symbols;
	var_array_cf_t data_symbols;

	float preamble_correlation_peak;

	float header_rssi;       // in dB
	float data_rssi;         // in dB
	float noise_floor_level; // in dB

	float carrier_tracked_freq;  // in Hz
	float initial_freq_offset;   // in Hz
	float final_freq_offset;     // in Hz

	float header_evm; // average error vector magnitude over header
	float data_evm;   // average error vector magnitude over data
} rx_packet_dbg_t;


typedef struct {
	size_t preambles_found;
	size_t successful_decodes;
	size_t failed_decodes;
	size_t header_errors;
} rx_stats_t;

#endif // DEBUG_STRUCTS_H
