#ifndef LAYER1_MODCOD_H
#define LAYER1_MODCOD_H

#include <liquid/liquid.h>

// up to 32 ModCods are supported. Do not reuse indices, as that will break
// backwards compatibility! Only append new ModCods at the end of the list!
typedef enum
{
	MODCOD_16QAM_CONV_V27P34,
	MODCOD_QPSK_CONV_V27P34,

	MODCOD_LIST_SIZE
} modcod_t;

#define MODCOD_DEFAULT MODCOD_16QAM_CONV_V27P34

modem modcod_create_modem(modcod_t modcod);
fec   modcod_create_fec(modcod_t modcod);

#define MODCOD_IS_VALID(modcod) ((modcod) < MODCOD_LIST_SIZE)

#endif // LAYER1_MODCOD_H
