#include <stdbool.h>

#include "config.h"

#include "preamble.h"

#define PREAMBLE_LEN ((1 << PREAMBLE_MSEQ_M) - 1)

static float complex symbol_cache[PREAMBLE_LEN];
static bool          symbol_cache_initialized = false;

const float complex* preamble_get_symbols(void)
{
	if(!symbol_cache_initialized) {
		msequence mseq = msequence_create(
				PREAMBLE_MSEQ_M,
				PREAMBLE_MSEQ_POLY,
				PREAMBLE_MSEQ_INIT);

		for(unsigned i = 0; i < PREAMBLE_LEN; i++) {
			unsigned int bit = msequence_advance(mseq);
			symbol_cache[i] = bit ? -1.0f : 1.0f;
		}

		msequence_destroy(mseq);

		symbol_cache_initialized = true;
	}

	return symbol_cache;
}


size_t preamble_get_symbol_count(void)
{
	return PREAMBLE_LEN;
}
